' Spiderbot hand control v1.0 Jan 26 2014
' follows your hand, tries to keep sensor ~7" away from hand


#picaxe 20m2
#no_data

fvrsetup FVR4096 ; set FVR as 4.096 V
adcconfig %011 ; set FVR as ADC Vref+, 0V Vref-

symbol rightstop=145:servo 4,rightstop  'right servo null=145   fwd=125   rev=165 
symbol leftstop=142 :servo 5,leftstop   'left servo null=142    fwd=162   rev=122 
'B.6 Sharp IR servo ADC
servo 7,150                             ' center IR sensor servo 70=full ccw 220=full cw 
gosub beep  

main:
readadc b.6,b0  ' sets b.6 in adc mode   nothing<35   6"=90  8"=75   12"=48
pause 100		  
if b0<40 then scan  ' nothing seen straight ahead, so scan for object
b1=rightstop-90+b0:servopos 4,b1    'adjust servo speed based on distance
b2=leftstop +90-b0:servopos 5,b2
goto main

scan:					' scan for hand using Sharp sensor
let adcsetup = %0000000    	' return pin b.6 to digital mode from adc
servo 4,rightstop  		' stop walking 
servo 5,leftstop 

for b0=70 to 220 step 5		' scan clockwise
servopos 7,b0
if pinb.6=1 then follow		' object seen, jump to follow
pause 15
next

for b0=220 to 70 step -5	' scan counterclockwise
servopos 7,b0
if pinb.6=1 then follow		' object seen, jump to follow
pause 15
next
goto scan

follow:
servopos 7,150 			' aim sensor straight ahead
if b0>135 and b0<165 then main	' object straight ahead, no need to turn
if b0<136 then left
if b0>164 then right

left:
do
servopos 4,125:servopos 5,122 	' turn left
pause 100
if pinb.6=1 then main			' exit when hand seen
loop
	
right:
do
servopos 4,165:servopos 5,162 	' turn right
pause 100
if pinb.6=1 then main			' exit when hand seen
loop

beep:
for b7=1 to 10
toggle c.7
pause 50
next
return
